-------------------------------------------------------------------------
---------------- SpiderMan net shot by Joni And Friends -----------------
-------------------------------------------------------------------------
-------------------------------------------------------------------------

function totable(t,match)
	local cmd = {}
	if not match then match = "[^%s]+" end
	for word in string.gmatch(t, match) do
		table.insert(cmd, word)
	end 
	return cmd 
end

---==== Table's ====---
sp_shotIMG={}
sp_shotx={}
sp_shoty={}

---==== Settings ====---
sp_maxshot=7  -- maximum net shot(7 default)
sp_hitteam=0 -- (1 = enable,0 = disable)
sp_nettime=5 -- time removed the image net(in second)
sp_netcolour={255,255,255} -- Spider net colour({255,255,255} is the default)


---==== Hooks ====---
addhook("join","sp_join")
addhook("attack","sp_attack")
addhook("clientdata","sp_clientdata")
addhook("leave","sp_leave")
addhook("startround_prespawn","sp_startroundP")


---==== Functions ====---

function sp_join(id)
       sp_shotIMG[id]={}
       sp_shotx[id]=0
       sp_shoty[id]=0
       for i=1,sp_maxshot do
             sp_shotIMG[id][i]=nil
       end
end

function sp_attack(id)
wpn=player(id,"weapontype")
     if wpn==50 then
         reqcld(id,2)
     end
end

function sp_clientdata(id,m,x,y)
      if m==2 then
           sp_shotx[id]=x
           sp_shoty[id]=y
           sp_shotnow(id)
      end
end

function sp_leave(id)
      for i=1,sp_maxshot do
             freeimagesp(id,i)
      end
end

function sp_startroundP()
      for _,id in pairs(player(0,"table")) do
            for i=1,sp_maxshot do
                freeimagesp(id,i)
            end
      end
end

function sp_shotnow(id)
      for i=1,sp_maxshot do
          if sp_shotIMG[id][i]==nil then
              sp_shotIMG[id][i]=image("gfx/JAF/line.png",player(id,"x"),player(id,"y"),3)
              imagepos(sp_shotIMG[id][i],player(id,"x"),player(id,"y"),player(id,"rot"))
              imagecolor(sp_shotIMG[id][i],sp_netcolour[1],sp_netcolour[2],sp_netcolour[3])
              imagescale(sp_shotIMG[id][i],0.4,5)
              tween_scale(sp_shotIMG[id][i],500,0.1,0.4)
              tween_move(sp_shotIMG[id][i],500,sp_shotx[id],sp_shoty[id],player(id,"rot"))
              timer(500,"sp_imageremove",""..id.." "..i.."")
              return 1
           end
       end
end

function freeimagesp(id,z)
      if sp_shotIMG[id][z]~=nil then
              freeimage(sp_shotIMG[id][z])
              sp_shotIMG[id][z]=nil
      end
end

function sp_imageremove(id)
tbm=totable(id)
id=tonumber(tbm[1])
iimg=tonumber(tbm[2])
freeimagesp(id,iimg)
dmg=math.random(10,30)
              sp_shotIMG[id][iimg]=image("gfx/spideyget.png",sp_shotx[id],sp_shoty[id],3)
              imagepos(sp_shotIMG[id][iimg],sp_shotx[id],sp_shoty[id],player(id,"rot"))
              imagecolor(sp_shotIMG[id][iimg],sp_netcolour[1],sp_netcolour[2],sp_netcolour[3])
              for _,pl in pairs(player(0,"tableliving")) do
                    if player(pl,"tilex")==math.floor(((sp_shotx[id]-16)/32)) and player(pl,"tiley")==math.floor(((sp_shoty[id]-16)/32)) then
                         parse("speedmod  "..pl.." -100")
                        if sp_hitteam==1 and player(id,"team")==player(pl,"team") or sp_hitteam==0 and player(id,"team")~=player(pl,"team") or sp_hitteam==1 and player(id,"team")~=player(pl,"team")  then
                        if dmg<player(pl,"health") then
                            parse("sethealth   "..pl.." "..player(pl,"health")-dmg)
                        else
                            parse("customkill "..id.." \"Net Spider\" "..pl)
                        end
                        end
                         timer(sp_nettime*1000,"sp_playernormal",""..pl.."")
                         function sp_playernormal(id)
                         id=tonumber(id)
                         parse("speedmod  "..id.." 0")
                         end
                    end
              end
                        timer(sp_nettime*1000,"sp_imageremove2",""..id.." "..iimg.."")
                         function sp_imageremove2(id)
                         tbm2=totable(id)
                         id=tonumber(tbm2[1])
                         iimg=tonumber(tbm2[2])
                         freeimagesp(id,iimg)
                         end
end